﻿public class MoreTreasure : Mod
{
    private HarmonyLib.Harmony harmony;
    private static string modId = "com.raftmodding.mods.more-treasure";
    private static int smallMin = 1;
    private static int smallMax = 1;
    private static int bigMin = 2;
    private static int bigMax = 3;
    private static int balboaMin = 3;
    private static int balboaMax = 6;
    private static void SetNumberOfTreasures()
    {
        foreach (SO_TreasureLootSettings treasureLootSetting in UnityEngine.Resources.LoadAll<SO_TreasureLootSettings>("SO_TreasureLootSettings"))
        {
            switch (treasureLootSetting.name)
            {
                case "TreasureLootSettings_LandmarkSmall": smallMin = treasureLootSetting.numberOfTreasures.minValue; smallMax = treasureLootSetting.numberOfTreasures.maxValue; break;
                case "TreasureLootSettings_LandmarkBig": bigMin = treasureLootSetting.numberOfTreasures.minValue; bigMax = treasureLootSetting.numberOfTreasures.maxValue; break;
                case "TreasureLootSettings_LandmarkBalboa": balboaMin = treasureLootSetting.numberOfTreasures.minValue; balboaMax = treasureLootSetting.numberOfTreasures.maxValue; break;
            }
        }
    }
    public void Start()
    {
        SetNumberOfTreasures();
        harmony = new HarmonyLib.Harmony(modId);
        harmony.PatchAll();
    }
    public override void WorldEvent_WorldLoaded()
    {
        SetNumberOfTreasures();
    }
    public void OnModUnload()
    {
        harmony.UnpatchAll(modId);
        foreach (SO_TreasureLootSettings treasureLootSetting in UnityEngine.Resources.LoadAll<SO_TreasureLootSettings>("SO_TreasureLootSettings"))
        {
            switch (treasureLootSetting.name)
            {
                case "TreasureLootSettings_LandmarkSmall": treasureLootSetting.numberOfTreasures = new Interval_Int() { minValue = smallMin, maxValue = smallMax }; break;
                case "TreasureLootSettings_LandmarkBig": treasureLootSetting.numberOfTreasures = new Interval_Int() { minValue = bigMin, maxValue = bigMax }; break;
                case "TreasureLootSettings_LandmarkBalboa": treasureLootSetting.numberOfTreasures = new Interval_Int() { minValue = balboaMin, maxValue = balboaMax }; break;
            }
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(TreasurePointManager), "Start")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_TreasurePointManager_Start
    {
        static void Postfix(ref SO_TreasureLootSettings[] ___treasureLootSettings)
        {
            foreach (SO_TreasureLootSettings treasureLootSetting in ___treasureLootSettings)
            {
                switch (treasureLootSetting.name)
                {
                    case "TreasureLootSettings_LandmarkSmall": treasureLootSetting.numberOfTreasures = new Interval_Int() { minValue = 3, maxValue = 3 }; break;
                    case "TreasureLootSettings_LandmarkBig": treasureLootSetting.numberOfTreasures = new Interval_Int() { minValue = 9, maxValue = 9 }; break;
                    case "TreasureLootSettings_LandmarkBalboa": treasureLootSetting.numberOfTreasures = new Interval_Int() { minValue = 18, maxValue = 18 }; break;
                }
            }
        }
    }
}
